/*----------------------------------------------------------------------------}
{- the dataheader definitions and code for sending.
{- most of it comes directly from G's code, simply because it's the best way i could
{- think of doing it, and his code seems to work, so i'm not going to rehash it.
{----------------------------------------------------------------------------*/

//package cypher;

import java.io.*;

public class DataHeader
{
  byte Command;
  byte Param1;
  byte Param2;
  byte Param3;
  int PacketSize;
  
  public DataHeader(int nCommand, int nParam1, int nParam2, int nParam3, int nPS) {
    Command = (byte)nCommand;
    Param1 = (byte)nParam1;
    Param2 = (byte)nParam2;
    Param3 = (byte)nParam3;
    PacketSize = nPS;
  }

  // re-introduced this 18/1/2001
  public DataHeader()
    {
        Command = (byte)0;
        Param1 = (byte) 0;
        Param2 = (byte) 0;
        Param3 = (byte) 0;
        PacketSize = 0;
    }

  public void send(DataOutputStream outStream) throws IOException {
    byte[] loginPacket = new byte[8];
        
        loginPacket[0]=Command;
        loginPacket[1]=Param1;
        loginPacket[2]=Param2;
        loginPacket[3]=Param3;

        long lTemp; 
        if (PacketSize >= 0)
        {
            loginPacket[4] = (byte)( (PacketSize / 16777216 ) % 256 );
            loginPacket[5] = (byte)( (PacketSize / 65536 ) % 256 );
            loginPacket[6] = (byte)( (PacketSize / 256 ) % 256 );
            loginPacket[7] = (byte)( (PacketSize) % 256 );
        }
        else
        {
            loginPacket[4] = 0;
            loginPacket[5] = 0;
            loginPacket[6] = 0;
            loginPacket[7] = 0;
        }
        
        outStream.write(loginPacket);

        outStream.flush();
    } // end DataHeader.send

    public void recv(DataInputStream inStream) throws IOException
    {
      Command = 0;
      Param1 = 0;
      Param2 = 0;
      Param3 = 0;
      PacketSize = 0;
    
      if (inStream == null)
      {
        System.out.println("DataHeader.recv: inStream is null");
        return;
      }
      Command = inStream.readByte();
      Param1 = inStream.readByte();
      Param2 = inStream.readByte();
      Param3 = inStream.readByte();
      PacketSize = inStream.readInt();
    } // end DataHeader.recv

    public int getCommand()
    {
        return Command;
    }

    public int getParam1()
    {
        return Param1;
    }

    public int getParam2()
    {
        return Param2;
    }
    
    public int getParam3()
    {
        return Param3;
    }

    public int getPacketSize()
    {
        return PacketSize;
    }

    public void setCommand(int i)
    {
        Command = (byte)i;
    }

    public void setParam1(int i)
    {
        Param1 = (byte)i;
    }
    
    public void setParam2(int i)
    {
        Param2 = (byte)i;
    }

    public void setParam3(int i)
    {
        Param3 = (byte)i;
    }

    public void setPacketSize(int i)
    {
        PacketSize = i;
    }

} // end DataHeader class
