/*----------------------------------------------------------------------------}
{- the file that handles user input.
{-
{- this file contains: 
{-
{- User_in(DataInputStream in, DataOutputStream out)
{- parse_req(String request, DataOutputStream out)
{- logOut()
{- Send(int SYS)
{- replyTo(int userID)
{- showUserlist()
{- Examine(DataOutputStream out)
{- goInvis()
{- doPing()
{- changePopname()
{- showStatus()
{- showHelp()
{- doZap()
{- goUltraInvis()
{- bMail()
{----------------------------------------------------------------------------*/

//package cypher

import java.io.*;
import java.net.*;

public class Input implements Constants
{
//  private static String message; //once the package bit works OK, this can be removed, and uncommented from Cypher.java
  
  /*----------------------------------------------------------------------------}
  {- this is the loop that sits and waits for user input, which is then parsed
  {- by parse_req. :)
  {----------------------------------------------------------------------------*/
  public static void User_in(DataInputStream in, DataOutputStream out/*, User spod*/)
  {
    String request = new String();
    BufferedReader userInput = new BufferedReader(new InputStreamReader(System.in));
    for (;;)
    {
      try
      {
        request = userInput.readLine();       
      }
      catch (IOException eInput)
      {
        System.err.println(eInput);
        System.out.println("Error reading in user request.");
      }
      parse_req(request, out);
    }
  } // end User_in


  /*----------------------------------------------------------------------------}
  {- this takes what the user typed, and, if valid, runs the appropriate function.
  {- otherwise, it tells the user that what they typed was rubbish. :)
  {----------------------------------------------------------------------------*/
  public static void parse_req(String request, DataOutputStream out)
  {
    // this is a horrible piece of code. i hate it, but am too lazy to change it atm. :)
    // it won't, of course, be necessary in GUI.
    int iRequest=-1;
    request=request.toUpperCase();
    
    // these need re-jigging to reflect importance / sensible-ness. :)
    if (request.equalsIgnoreCase("QUIT")) iRequest = 0;
    if (request.equalsIgnoreCase("SEND")) iRequest = 1;
    if (request.equalsIgnoreCase("REPLY")) iRequest = 2;
    if (request.equalsIgnoreCase("LIST")) iRequest = 3;
    if (request.equalsIgnoreCase("EXAMINE")) iRequest = 4;
    if (request.equalsIgnoreCase("INVIS")) iRequest = 5;
    if (request.equalsIgnoreCase("PING")) iRequest = 6;
    if (request.equalsIgnoreCase("POP")) iRequest = 7;
    if (request.equalsIgnoreCase("STATUS")) iRequest = 8;
    if (request.equalsIgnoreCase("HELP")) iRequest = 9;
    if (request.equalsIgnoreCase("BMAIL")) iRequest = 10;
    if (request.equalsIgnoreCase("AFK")) iRequest = 11;
    if (request.equalsIgnoreCase("REGISTER")) iRequest = 15; // oooh. let the user register themselves.
    if (request.equalsIgnoreCase("CONF")) iRequest = 16;
    /* end normal functions */
    if (request.equalsIgnoreCase("ZAP")) iRequest = 12;
    if (request.equalsIgnoreCase("SYSMSG")) iRequest = 13;
    if (request.equalsIgnoreCase("ULTRA")) iRequest = 14;
    /* end BM functions */
    if (request.equalsIgnoreCase("TEST")) iRequest = 99;

    switch(iRequest) 
    {
      case 0: /*System.out.println("quit");*/
                   logOut();
                   break;
      case 1:      Send(0);
                   break;
      case 2: System.out.println("Replying to "+Utils.IDToName(Cypher.lastSender));
                   if (Cypher.lastSender>0) {
                     replyTo(Cypher.lastSender);
                   }else 
                   break;
      case 3: System.out.println("Current userlist:");
                   showUserlist();
                   //newUserList(); // ask the server for a new userlist? 
                                    //it sends so often anyway, is it necessary? yes.:) 
                   break;
      case 4: System.out.println("examine who?");
                   Examine(); 
                   break;
      case 5: goInvis();
                   break;
      case 6: System.out.println("pinging the server");
                   doPing();
                   break;
      case 7: System.out.println("change popname to what?");
                   changePopname();
                   break;
      case 8: System.out.println("Checking Status...");
                   showStatus();
                   break;
      case 9: showHelp();
                   break;     
      case 10: bMail();
                   break;
      case 11: goAFK();
                   break;
      case 12: if (Cypher.spod.Privs > S_BM) {doZap(); }//  <-----
               else {System.out.println("You are not authorised to zap someone.");}
                   break;
      case 13: if (Cypher.spod.Privs > S_BM) {Send(1); }//  <-----
               else System.out.println("You are not authorised to send a system message.");
                   break;
      case 14: if (Cypher.spod.Privs > S_BM){goUltraInvis(); }//  <-----
               else System.out.println("You are not authorised to go ultra-invis.");
                   break;
      case 15: registerUser();
                   break;
      case 16: enterConf();
                   break;
      default : System.out.println("Command not recognised, sorry. Try typing HELP.");
                   break;
    }
  }// end parse_req


  /*----------------------------------------------------------------------------}
  {- we've had a request to log out, so do it.
  {- close the streams down, close the socket, tell the user.
  {- is there any pending information?
  {----------------------------------------------------------------------------*/  
  public static void logOut()
  {
    try {
      // check to see if these streams are already closed before trying to close them again!
      //Cypher.in.close();    
      //Cypher.out.close();
      //Cypher.bSocket.close(); //not closing this explicitly stops the errors on closing, but is crap!
      System.out.println("logging you out..");
      Cypher.DEBUG("******** FINISHED ********");
      Cypher.DEBUGSTREAM.close();
      // stop the reader thread. break out of this loop. close the program.
      System.exit(0);
    }
    catch (IOException eLogout) {
      System.out.println("Error trying to log out.");
      System.err.println(eLogout);
    }
  }


  /*----------------------------------------------------------------------------}
  {- the send message function. asks who to send to, then posts off the request.
  {- the return details are dealt with by the listener thread.
  {- If SYS is 1 then this is a system message, so we don't need to get the user,
  {- KLUDGE KLUDGE KLUDGE KLUDGE KLUDGE! SORT THIS OUT!
  {----------------------------------------------------------------------------*/  
  public static void Send(int SYS)
  {
    String line="";
    String next="";
    String message="";
    char user = (char)Cypher.spod.ConnectionNum; // send to self if all goes balls up somewhere. :)
    int check=0;
    DataHeader sendHeader;
    BufferedReader getInput = new BufferedReader(new InputStreamReader(System.in));
    String crlf = System.getProperties().getProperty("line.separator");
    
    try {      
      // sort out who to send it to
      if (SYS==0) {
        System.out.println("send to who?");
        String userID = getInput.readLine();
        // not the best way of seeing if the user has entered a number or not!
        if (Character.isDigit(userID.charAt(0))==true) {
          int tInt = Integer.parseInt(userID);
          user = (char)tInt;
        }
        else if (Utils.NameToID(userID)>0) {
          user = (char)Utils.NameToID(userID);
        }
        else {
          System.out.println("Unable to send to that user. Can't find connection number");
          check = 1;
        }
      }      
      else {
        user = (char)0; // i.e. this is a SYSTEM MESSAGE
      }

      // now get the message.
      if (check==0) {
        System.out.println("Enter the message. End with a '.' on a line by itself.");
        for(;;) {
          line = getInput.readLine();
          for (int i = 0; i < line.length(); i++) {
            if (line.charAt(i) == '|') {
              next = crlf + line.substring(i + 1, line.length());
              line = line.substring(0, i) + next;
            }
          }
          message = message+line;
          if (line.equals(".")) break;
          else {line = ""; next = "";}
        }
      
        // set up things to send
        String messagePacket=user + message;
        int messagesize=messagePacket.length();
        System.out.println(messagePacket); // DEBUG
        
        if (SYS==0) sendHeader = new DataHeader(C_MSG_SEND,1,0,0,messagesize);
        else sendHeader = new DataHeader(C_MSG_SEND,0,P_MSG_SYS,0,messagesize);

        // and send them!
        sendHeader.send(Cypher.out);
        Cypher.out.writeBytes(messagePacket);
        Cypher.out.flush();
        if (Cypher.AFK==1){Cypher.AFK=0;} //if AFK was set, unset it.
      }// end if (check==0);
    }
    catch (NumberFormatException eNumber)
    {
      System.err.println(eNumber);
      System.out.println("Cypher was unable to parse that user number. Tell Pip what you did.");
    }
    catch (IOException eInput)
    {
      System.err.println(eInput);
      System.out.println("Error in send function. IO.");
    }
  }  

  /*----------------------------------------------------------------------------}
  {- and finally, the reply function. :) Wednesday 04/04/2001
  {- add some code in case the user enters a reply and no one has yet sent so that
  {- it gets sent back to them :)
  {----------------------------------------------------------------------------*/
  public static void replyTo(int userID)
  {
    try
    {
    String line = "";
    String next="";
    String message="";
    char user = (char)userID;
    DataHeader replyHeader;
    BufferedReader getInput = new BufferedReader(new InputStreamReader(System.in));
    String crlf = System.getProperties().getProperty("line.separator");

    System.out.println("Enter the message. End with a '.' on a line by itself.");
    for(;;) {
      line = getInput.readLine();
      for (int i = 0; i < line.length(); i++) {
        if (line.charAt(i) == '|') {
          next = crlf + line.substring(i + 1, line.length());
          line = line.substring(0, i) + next;
        }
      }
      message = message+line;
      if (line.equals(".")) break;
      else {line = ""; next = "";}
    }
      
    // set up things to send
    String messagePacket=user + message;
    int messagesize=messagePacket.length();
    replyHeader = new DataHeader(C_MSG_SEND,1,0,0,messagesize);

    // and send them!
    replyHeader.send(Cypher.out);
    Cypher.out.writeBytes(messagePacket);
    Cypher.out.flush();
    if (Cypher.AFK==1){Cypher.AFK=0;} //if AFK was set, unset it.
    }
    catch (IOException eReply) {
    System.out.println("Error trying to reply to "+Utils.IDToName(userID));
    }
  }// end replyTo
  
  /*----------------------------------------------------------------------------}
  {- showUserlist() - get the users on the board, alphabetise them and display!
  {- this is a shitty sorting algorithm. WHICH DOESN'T WORK
  {----------------------------------------------------------------------------*/
  public static void showUserlist()
  {
    NewSpod tSpod = new NewSpod();
    NewSpod minSpod = new NewSpod();

    for (int x=0;x<Cypher.userList.size() ;x++ ) {
      tSpod = (NewSpod)Cypher.userList.elementAt(x);
      System.out.println(Utils.getMarker(tSpod.Privs)+" - "+Integer.toString(tSpod.ConID)+" - "+tSpod.Username+" - "+tSpod.Popname);
    }
  }

  /*----------------------------------------------------------------------------}
  {- the examine user function. asks who to examine, then posts off the request.
  {- the return details are dealt with by the listener thread.
  {- it would be nice if this took in a parameter (username/ID)
  {----------------------------------------------------------------------------*/  
  public static void Examine()
  {
    String target="";
    BufferedReader getTarget = new BufferedReader(new InputStreamReader(System.in));
    try
    {
      target = getTarget.readLine();
      DataHeader examineHeader = new DataHeader(C_USER_GET, 0, 0, 0, target.length());
      examineHeader.send(Cypher.out);
      Cypher.out.writeBytes(target);
      Cypher.out.flush();
    }
    catch (IOException eExamine)
    {
      System.err.println(eExamine);
      System.out.println("Error doing Examine.");
    }
  } 


  /*----------------------------------------------------------------------------}
  {- standard invis code which sets a flag to tell cypher if typing INVIS should
  {- set the user INVIS or VISIBLE
  {----------------------------------------------------------------------------*/
  // SHOULD CHANGE THIS TO BITWISE AND with S_INVIS_LOGIN and S_ULTRAINVIS_LOGIN
  // for checking if invis or not. can then remove the fields from spod.
  // remember, that it's our NEWSPOD entry we have to check.
  public static void goInvis()
  {
    try
    {
      DataHeader invisHeader;
      if (Cypher.spod.Invis == false)// flag is zero, so we're visible. let's go invis!
      {
        if (Cypher.spod.Ultra==true) { // we're already ultra-invis, so let's keep it that way.
          invisHeader = new DataHeader(C_STATUS_SET, Cypher.spod.ConnectionNum, 1, 1, 0);
        }
        else {
          invisHeader = new DataHeader(C_STATUS_SET, Cypher.spod.ConnectionNum, 1, 0, 0);
        }
        invisHeader.send(Cypher.out);
        Cypher.spod.Invis = true; //set flag to show invis status
        System.out.println("you are INVIS");
      }
      else { //remove invisibility
        if (Cypher.spod.Ultra==true) { // we're already ultra-invis, so let's keep it that way.
          invisHeader = new DataHeader(C_STATUS_SET, Cypher.spod.ConnectionNum, 0, 1, 0);
        }        
        else {
          invisHeader = new DataHeader(C_STATUS_SET, Cypher.spod.ConnectionNum, 0, 0, 0);
        }
        invisHeader.send(Cypher.out);
        Cypher.spod.Invis = false;
        System.out.println("you are no longer INVIS");
      }
    }
    catch (IOException eInvis)
    {
      System.err.println(eInvis);
      System.out.println("error whilst going Invisible/Visible.");
    }
  }


 /*----------------------------------------------------------------------------}
 {- Set a boolean variable that can be checked to see if the server sends us a 
 {- PING_REPLY so we know we are being answered. (just for user information)
 {----------------------------------------------------------------------------*/
  public static void doPing()
  {
    try
    {
      DataHeader pingHeader = new DataHeader(C_PING_REQ, Cypher.spod.ConnectionNum, 0, 0, 0);
      pingHeader.send(Cypher.out);      
    }
    catch (IOException ePingReq)
    {
      System.err.println(ePingReq);
      System.out.println("error whilst doing ping request");
    }
  }


  /*----------------------------------------------------------------------------}
  {- the user has already been asked for his popname in the switch statment, so
  {- take it in and set it.
  {- This function should also be available to BM's, so they can change a user's
  {- popname in case it's offensive? probably.
  {----------------------------------------------------------------------------*/
  public static void changePopname()
  {
    int mes_len;
    String newpopname="";
    BufferedReader getInput = new BufferedReader(new InputStreamReader(System.in));
    try
    {
      newpopname = getInput.readLine();
      if (newpopname.length() > 0)
      {
        System.out.println("changing popname...");
        String popnameInfo = Cypher.spod.Username + newpopname+" ";

        DataHeader popHeader = new DataHeader(C_USER_PUT, U_POPNAME,Cypher.spod.Username.length(),newpopname.length() , popnameInfo.length());
        popHeader.send(Cypher.out);
        Cypher.out.writeBytes(popnameInfo);
        Cypher.out.flush();
        // we check this was done by the server sending your details back, showing the popname change.
      }
      else System.out.println("leaving popname unchanged");
    }
    catch (IOException ePopname)
    {
      System.err.println(ePopname);
      System.out.println("error whilst changing popname");
    }
  }

 /*----------------------------------------------------------------------------}
 {- show the user their username, connection number and current cookie.
 {----------------------------------------------------------------------------*/
  public static void showStatus()
  {
    System.out.println("You are: "+Cypher.spod.Username);
    System.out.println("Your connection number is: "+Cypher.spod.ConnectionNum);
    System.out.println("Your popname is: "+Cypher.spod.Popname);
    if (Cypher.spod.Invis==false && Cypher.spod.Ultra==false) {
      System.out.println("You are VISIBLE");
    }else if (Cypher.spod.Invis==false && Cypher.spod.Ultra==true){
      System.out.println("You are ULTRA-INVISIBLE");
    }else if (Cypher.spod.Invis==true && Cypher.spod.Ultra==false){
      System.out.println("You are INVISIBLE");
    }else if (Cypher.spod.Invis==true && Cypher.spod.Ultra==true){
      System.out.println("You are both INVISIBLE _and_ ULTRA-INVISIBLE");
    }

  }

  /*----------------------------------------------------------------------------}
  {- bog standard help screen. list of commands.
  {----------------------------------------------------------------------------*/
  public static void showHelp()
  {
    System.out.println("Valid commands for [cypher] are as follows:");
    System.out.println("    SEND - send a message (currently user connection ID must be used)");
    System.out.println("    REPLY - reply to the last message received");
    System.out.println("    LIST - show the current userlist");
    System.out.println("    EXAMINE - examine a user");
    System.out.println("    INVIS - turn invis (and back again)");
    System.out.println("    PING - ping the server");
    System.out.println("    POP - change your popname");
    System.out.println("    BMAIL - send an internal babel-mail to someone");
    System.out.println("    STATUS - looks at your current username and connection ID");
    System.out.println("    AFK - sets you Away From Computer or not. Sending a message also registers you as back.");
    System.out.println("    ZAP - zap somone (priv dependent)");
    System.out.println("    SYSMSG - send a system message (priv dependent)");
    System.out.println("    ULTRA - go ultra-invis and back again (priv dependent)");
    System.out.println("    HELP - get this message!");
    System.out.println("=====================================================================");
    System.out.println("(These commands are case insensitive)");
  }

  /*----------------------------------------------------------------------------}
  {- get the user to bmail, get the message, then send them!
  {- how to check the username is valid???
  {----------------------------------------------------------------------------*/
  public static void bMail()
  {
    String line="";
    String message="";
    BufferedReader getInput = new BufferedReader(new InputStreamReader(System.in));

    try
    {
      System.out.println("Post a message to who?");
      String user = getInput.readLine(); 

      // make sure a username was entered before trying to get the message!
      if (user.length()>0) {
        System.out.println("Enter the message. End with a '.' on a line by itself.");
        for(;;) {
          line = getInput.readLine();
          message = message+line;
          if ((line == null) || line.equals(".")) break;
        }
      }
      else System.out.println("you must enter a username to send to.");

      // make sure the user entered a message!
      if (message.length()>1) {
        DataHeader bmailHeader = new DataHeader(C_MAIL_SEND, user.length(),0,0,user.length()+message.length());
        bmailHeader.send(Cypher.out);
        Cypher.out.writeBytes(user);
        Cypher.out.writeBytes(message);
        // can those two be sent as one?
      }
      else System.out.println("You didn't type a message, the Bmail was not sent.");
    }
    catch (IOException eBMail)
    {
      System.out.println("Error whilst sending a BMail. "+eBMail);
    }
  }

  /*----------------------------------------------------------------------------}
  {- Stopped this being inline in case statement on Thursday 19/04/2001 so can 
  {- call it from Cypher.java when starting. Also better in long run.
  {----------------------------------------------------------------------------*/  
  public static void goAFK()
  {
    if (Cypher.AFK==0) { 
      Cypher.AFK=1;
      System.out.println("You are now AWAY");
      Cypher.DEBUG("You have become AFK");
    } else {
      Cypher.AFK=0;
      System.out.println("You are now BACK!");
      Cypher.DEBUG("You are no longer AFK");
    }
  }


  /*----------------------------------------------------------------------------}
  {- get the user number to zap, and zap them!
  {----------------------------------------------------------------------------*/
  public static void doZap()
  {
    BufferedReader getInput = new BufferedReader(new InputStreamReader(System.in));
    System.out.println("Zap who? (connection number only)");
    try
    {
      String temp = getInput.readLine();      
      int zapUser = Integer.parseInt(temp);
      // should check user is in the userlist here.
      DataHeader zapHeader = new DataHeader(C_USER_ZAP, 0, 0, zapUser, 0);
      zapHeader.send(Cypher.out);
    }
    catch (IOException eZap)
    {
      System.out.println("Error whilst trying to zap someone! "+eZap);
    }
  }

  /*----------------------------------------------------------------------------}
  {- code for going ultra-invis.
  {----------------------------------------------------------------------------*/
  public static void goUltraInvis()
  {
    try {
      DataHeader ultraHeader;
      if (Cypher.spod.Ultra==false) //ultra-invis isn't set, so let's set it!
      {
        if (Cypher.spod.Invis==true) { // we're invis, so let's keep it that way!
          ultraHeader = new DataHeader(C_STATUS_SET, Cypher.spod.ConnectionNum, 1, 1, 0);
        }
        else {
          ultraHeader = new DataHeader(C_STATUS_SET, Cypher.spod.ConnectionNum, 0, 1,0);
        }
        ultraHeader.send(Cypher.out);
        Cypher.spod.Ultra = true;
        System.out.println("you are ULTRA-INVIS");
      }
      else { //ultrainvis flag is set, so now let's take it off.
        if (Cypher.spod.Invis==true) { // we're invis, so let's keep it that way!
          ultraHeader = new DataHeader(C_STATUS_SET, Cypher.spod.ConnectionNum, 1, 0, 0);
        }
        else {
          ultraHeader = new DataHeader(C_STATUS_SET, Cypher.spod.ConnectionNum, 0, 0, 0);
        }
        ultraHeader.send(Cypher.out);
        Cypher.spod.Ultra = false;
        System.out.println("you are no longer ULTRA-INVISIBLE.");
      }
    }
    catch (IOException eUltra)
    {
      System.err.println(eUltra);
      System.out.println("error whilst going Ultra-Invisible/Visible.");
    }
  }

  /*----------------------------------------------------------------------------}
  {- code for letting a user register. Sunday 29/04/2001 
  {- stick registration in a big loop which checks server error returns.
  {- need username, real name, email, home city
  {- let the user cancel out by not entering a username.
  {----------------------------------------------------------------------------*/  
  private static void registerUser()
  {
    if (Cypher.spod.Username.equalsIgnoreCase("GUEST")) {
      BufferedReader getInput = new BufferedReader(new InputStreamReader(System.in));
      try {
        System.out.print("Enter your real name: ");
        String rName = getInput.readLine();
        System.out.print("Enter your email address: ");
        String rEmail = getInput.readLine();
        System.out.print("Enter your home town: ");
        String rCity = getInput.readLine();
        System.out.print("Enter the username you would like: ");
        String rUsername = getInput.readLine();
      }
      catch (IOException eRegister)  {
        System.out.println("Error whilst reading in user registration details");
      }      
      
    } else System.out.println("You are already a registered user.  You cannot register again!");
  }

  public static void enterConf()
  {
     System.out.println("user wants to enter conf!");
  }

} // end class