/* part of the Cypher program, a java client for babel.
 *
 * functions in this file are as follows:
 *
 *   -  doLogin(String, String)
 *   -  padIt(String)
 *
 */ 

//package cypher;

import java.io.*;
import java.net.*;

class Login implements Constants
{
  /*
   * this is the function which actually logs a user in.
   * it puts the username and password into the dataheader and sends them off to the server
   * 
   */
  public static int doLogin(String username, String password)
  {
    username=padIt(username);
    password=padIt(password);
    String loginInfo = username+password+CLIENT_STR;
    try
    {
      DataHeader loginHeader = new DataHeader(C_LOGIN, 0, 0, 0, loginInfo.length());
      loginHeader.send(Cypher.out);
      Cypher.out.writeBytes(loginInfo);
      Cypher.out.flush();
      return 0; 
    }
    catch (IOException e)
    {
       System.err.println(e);
       System.err.println("I/O error in doLogin");
    }
  return 1;
  } // end doLogin


  /*
   * quick function just to pad the fields to 16 to make the server happy.
   */
  public static String padIt(String word)
  {
    if (word=="") word="Guest";
    else if (word.length() > 16) return word.substring(0,16);
    for(; word.length() < 16; word = word + " ");
    return word;
  } //end padIt
} // end Login class