/*
 * the user running the client. YOU! the person running this! NO ONE ELSE!
 *
 */

import java.util.Date;
import java.io.*;

public class User implements Constants
{
  // stuff normally accessible from the client
  public String Username;
  public String Password;
  public String Popname;
  public String Status;
  public String RealName;
  public String City;
  public String SysComment;
  public String EmailAddress;
  public int ConnectionNum; //added 16/03/2001 for ease in other places - not stored on server (duh).
  public String Cookie;     //added 31/03/2001 again, for ease and to reduce overhead in other places.
  public static boolean Invis;
  public static boolean Ultra;
  
  public Date Created;
  public Date LastOn;
  public Date BannedUntil;
  public int ID;
  public int Privs;
  public int ShowDetails;
  public int LongestTimeOn; // do these actually come in?
  public int LongestTimeOnThisLeague; // just here for curiousity's sake, really.

  // create a new spod.
  public User() {
    //  Populate some fields
    this.Username = null;
    this.Popname = null;
    this.Privs = 0;     
    this.LastOn = null;
    this.Created = null;
    this.EmailAddress = null;
    this.Invis = false;
    this.Ultra = false;
    // can't be bothered with the others. 
    }

  // receive the user's profile as a byte array and convert it to understandable stuff.
  public User translate(byte[] bUser) {
    try
    {
      User spod = new User();

      //byte[] packet = new byte[0];

      DataInputStream userIn = new DataInputStream(new ByteArrayInputStream(bUser));

      // get the profile
      spod.ID = userIn.readInt(); //4
      spod.Created   =   Utils.makeDate(userIn);//8
      spod.LastOn    =   Utils.makeDate(userIn);//8
      spod.Username  =   Utils.makeString(userIn,W_USERNAME);//16
      spod.Password  =   Utils.makeString(userIn,W_PASSWORD);//16
      spod.EmailAddress= Utils.makeString(userIn,W_EMAIL);//64
      spod.Privs     =   userIn.readInt();//4
      spod.BannedUntil = Utils.makeDate(userIn);//8
      spod.ShowDetails = userIn.readInt();//4
      spod.Popname   =   Utils.makeString(userIn,W_MOTTO);//64
      spod.RealName  =   Utils.makeString(userIn,W_REALNAME);//32
      spod.City      =   Utils.makeString(userIn,W_CITY);//16
      spod.SysComment =  Utils.makeString(userIn,W_COMMENT);//200
      userIn.skip(5); // Control (1 byte plus prevpostings int)//5
      spod.Status    =   Utils.makeString(userIn,1);//1
      //System.out.println("user array size = "+bUser.length); // DEBUG
      return spod;
    }
    catch (IOException e)
    {
      System.out.println(e);
      System.out.println("error in decoding person details");
      return null;
    } 
  } // end User.transalte()

}
