/*----------------------------------------------------------------------------}
{-some general functions for use here and there in Cypher.
{-
{-containing: IDToName(int userID)
{-            NameToID(String uName)
{-            makeString(DataInputStream byteStream, int pLen) throws IOException
{-            makeDate(DataInputStream pByteStream) throws IOException
{-            String getDate()
{----------------------------------------------------------------------------*/

import java.io.*;
import java.util.*;

class Utils implements Constants
{
 /*----------------------------------------------------------------------------}
 {- quick and simple function to return the username of a user, given their
 {- connection number.
 {----------------------------------------------------------------------------*/
  public static String IDToName(int userID)
  {
    NewSpod xTarget = new NewSpod();
    for (int x=0; x < Cypher.userList.size(); x++) {
      xTarget = (NewSpod)Cypher.userList.elementAt(x);
      if (userID==xTarget.ConID) {
        System.out.println("Connection number "+userID+" is "+xTarget.Username); //DEBUG
        return xTarget.Username;
      }
    }
    System.out.println("Unable to translate ID number to a username. Userlist is clearly fucked. :)");
    return null;
  }

  /*----------------------------------------------------------------------------}
  {- take the name, loop through the userlist vector, find the name, and
  {- return the relevant ID. :)
  {----------------------------------------------------------------------------*/
  public static int NameToID(String uName)
  {
    NewSpod xTarget = new NewSpod();
    // System.out.println("there are "+Cypher.userList.size()+" entries in the vector"); //DEBUG
    for (int x=0; x < Cypher.userList.size(); x++) { //loop through the vector userlist
      xTarget = (NewSpod)Cypher.userList.elementAt(x);
      if (uName.equalsIgnoreCase(xTarget.Username)==true) {
        System.out.println(uName+" is connection number: "+xTarget.ConID); //DEBUG
        return xTarget.ConID;
      }
    }
    System.out.println("That user was not found in the userlist. Make sure they're still logged in and you spelt the name correctly.");
    return -1;
  }

  /*----------------------------------------------------------------------------}
  {- Creates a string from the passed in stream
  {- declare a byte array, set it to the length of the stream to convert
  {- typecast it and return.
  {----------------------------------------------------------------------------*/
  public static String makeString(DataInputStream byteStream, int pLen) throws IOException
  {
      byte[] temp;                       
      temp = new byte[pLen];
      byteStream.read(temp);
      return new String(temp).trim();
  } 

  /*----------------------------------------------------------------------------}
  {-This will read a legacy date off the passed in stream
  {- I'll add this code one day. :)
  {----------------------------------------------------------------------------*/  
  public static Date makeDate(DataInputStream pByteStream) throws IOException
  {     
    //TODO: We aren't creating a date here, just skipping the 8 bytes
    pByteStream.skip(8);
    return new Date();
  } 

  /*----------------------------------------------------------------------------}
  {- Gets the current date and time for use in the DEBUG file.
  {----------------------------------------------------------------------------*/  
  public static String getDate()
  {
    Calendar calendar = new GregorianCalendar();
    String dateAndTime = new String(calendar.get(Calendar.DATE) + "/"
                              + calendar.get(Calendar.MONTH) + "/"
                              + calendar.get(Calendar.YEAR) + " - "
                              + calendar.get(Calendar.HOUR_OF_DAY) + ":"
                              + calendar.get(Calendar.MINUTE) + ":"
                              + calendar.get(Calendar.SECOND));
    return dateAndTime;
  }

  /*----------------------------------------------------------------------------}
  {- instead of this, have one function which returns priv level or marker 
  {- depending on a Boolean Constant?
  {----------------------------------------------------------------------------*/
  public static String getMarker(int privs)
  {
	String marker;
    marker = "?";
    if (privs >= S_AUTHOR) {
		privs = privs - S_AUTHOR - S_REGISTERED;
        marker = "*";
	} else if (privs >= S_BM) {
		privs = privs - S_BM - S_REGISTERED;
        marker = "#";
	} else if (privs >= S_SYSOP) {
		privs = privs - S_SYSOP - S_REGISTERED;
        marker = "^";
	} else if (privs >= S_REGISTERED) {
		privs = privs - S_REGISTERED;	
        marker = "-";
	}
    if ((privs & S_INVIS_LOGIN)==S_INVIS_LOGIN) marker = "i"; 
    if ((privs & S_ULTRAINVIS_LOGIN)==S_ULTRAINVIS_LOGIN) marker = "u";	

    return marker;
  }

}//end Utils
